// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
string dir_symb = "^>v<";

int get_dir(char c) {
	for (int i = 0; i < 4; ++i) {
		if (c == dir_symb[i]) {
			return i;
		}
	}
	return -1;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int k = n;
	int percent = atoi(argv[2]);

	vector<vector<char>> outp(n, vector<char>(n, '.'));

	for (int i = 0; i < k; ++i) {
		outp[i][i] = 'O';
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (outp[i][j] != 'O') {
				outp[i][j] = '+';
			}
		}
	}

	vector<int> order;
	for (int i = 0; i < n - 1; ++i) {
		order.push_back(0);
		order.push_back(1);
	}

	shuffle(order.begin(), order.end());

	int x = 0, y = n - 1;
	for (int d : order) {
		if (rnd.next(0, 99) < percent) {
			outp[x][y] = '.';
		}
		if (d == 0) {
			++x;
		} else {
			--y;
		}
	}

	if (rnd.next(0, 99) < percent) {
		outp[x][y] = '.';
	}


	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << outp[i][j];
		}
		cout << "\n";
	}

	return 0;
}