// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n;
	cin >> n;
	vector<vector<char>> field(n, vector<char>(n));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < n; ++j) {
			field[i][j] = s[j];
		}
	}

	int k = atoi(argv[1]);

	for (int i = 0; i < k; ++i) {
		while (true) {
			int x = rnd.next(0, n - 1);
			int y = rnd.next(0, n - 1);
			if (field[x][y] != 'O') {
				if (field[x][y] == '.') {
					field[x][y] = '+';
				} else {
					field[x][y] = '.';
				}
				break;
			}
		}
	}

	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cout << field[i][j];
		}
		cout << "\n";
	}

	return 0;
}