#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>



using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

string s[500];

const int N = 500 * 500;

vector <int> g[N * 2], gr[N * 2];
int id[500][500];

void add_edge(int a, int b) {
  g[a].push_back(b);
  gr[b].push_back(a);
}

bool u[2 * N], vis[2 * N];

vector <int> t;

void dfs(int v) {
  u[v] = true;
  for (int to : g[v]) {
    if (!u[to]) {
      dfs(to);
    }
  }
  t.push_back(v);
}


int comp[2 * N];

int lmao = 0;

void zhfs(int v) {
  comp[v] = lmao;
  vis[v] = true;
  for (int to : gr[v]) {
    if (!vis[to]) {
      zhfs(to);
    }
  }
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  for (int i = 0; i < n; i++) {
    cin >> s[i];
  }
  int sz = 0;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (s[i][j] == '+') {
        id[i][j] = sz++;
      }
    }
  }
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (s[i][j] == '+') {
        {
          bool good = false;
          for (int x = 0; x < n; x++) {
            if (s[i][x] == 'O') {
              good = true;
              for (int t = 0; t < n; t++) {
                if (min(x, j) < t && t < max(x, j)) {
                  if (s[i][t] != '+') {
                    good = false;
                  }
                  add_edge(id[i][j] * 2 + 0, id[i][t] * 2 + 0);
                  add_edge(id[i][t] * 2 + 1, id[i][j] * 2 + 1);
                }
              }
            }
          }
          if (!good) {
            add_edge(id[i][j] * 2 + 0, id[i][j] * 2 + 1);
          }
        }
        {
          bool good = false;
          for (int x = 0; x < n; x++) {
            if (s[x][j] == 'O') {
              good = true;
              for (int t = 0; t < n; t++) {
                if (min(x, i) < t && t < max(x, i)) {
                  if (s[t][j] != '+') {
                    good = false;
                  }
                  add_edge(id[i][j] * 2 + 1, id[t][j] * 2 + 1);
                  add_edge(id[t][j] * 2 + 0, id[i][j] * 2 + 0);
                }
              }
            }
          }
          if (!good) {
            add_edge(id[i][j] * 2 + 1, id[i][j] * 2 + 0);
          }
        }
      }
    }
  }
  for (int i = 0; i < 2 * sz; i++) {
    if (!u[i]) {
      dfs(i);
    }
  }
  reverse(t.begin(), t.end());
  for (int v : t) {
    if (!vis[v]) {
      zhfs(v);
      lmao++;
    }
  }
  vector <char> ans(sz);
  for (int i = 0; i < sz; i++) {
    if (comp[2 * i] == comp[2 * i + 1]) {
      cout << "No\n";
      return 0;
    }
    if (comp[2 * i] < comp[2 * i + 1]) {
      ans[i] = '|';
    } else {
      ans[i] = '-';
    }
  }
  cout << "Yes\n";
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (s[i][j] == '+') {
        cout << ans[id[i][j]];
      } else {
        cout << s[i][j];
      }
    }
    cout << '\n';
  }
}
