// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	vector<int> vals = arr;
	sort(vals.begin(), vals.end());
	vals.erase(unique(vals.begin(), vals.end()), vals.end());

	for (int& num : arr) {
		num = lower_bound(vals.begin(), vals.end(), num) - vals.begin();
	}

	vector<vector<int>> where(szof(vals));
	for (int i = 0; i < n; ++i) {
		where[arr[i]].push_back(i);
	}

	int ans = 0;

	int cnt = 0;
	while (cnt < szof(vals)) {
		int to = cnt + 1;
		while (to < szof(vals) && where[to - 1].back() < where[to].front()) {
			++to;
		}

		int sum = 0;
		for (int i = cnt; i < to; ++i) {
			sum += szof(where[i]);
		}

		if (cnt > 0) {
			sum += lower_bound(where[cnt - 1].begin(), where[cnt - 1].end(), where[cnt].front()) - where[cnt - 1].begin();
		}

		if (to < szof(vals)) {
			sum += where[to].end() - lower_bound(where[to].begin(), where[to].end(), where[to - 1].back());
		}

		ans = max(ans, sum);

		cnt = to;
	}

	for (int i = 0; i < szof(vals) - 1; ++i) {
		for (int j = 0; j < szof(where[i]); ++j) {
			ans = max(ans, j + 1 + (int) (where[i + 1].end() - lower_bound(where[i + 1].begin(), where[i + 1].end(), where[i][j])));
		}
	}

	cout << n - ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}