// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXC = 1000, MAXT = 1000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int group = atoi(argv[1]);

	if (group == 1) {
		int sx = rnd.next(-MAXC, MAXC);
		vector<pair<pii, int>> points;
		points.push_back({{sx, 0}, 1});
		for (int i = 1; i < 1000; ++i) {
			int x = rnd.next(-MAXC, MAXC);
			points.push_back({{x, 0}, rnd.next(1, MAXT)});
		}
		shuffle(points.begin(), points.end());
		cout << sx << " 0 " << sx << " 0\n";
		cout << szof(points) << "\n";
		for (auto p : points) {
			cout << p.ff.ff << " " << p.ff.ss << " " << p.ss << "\n";
		}
	} else if (group == 2) {
		cout << "239 179 239 179\n1\n239 179 1\n";
	} else if (group == 3) {
		int sx = rnd.next(-MAXC, MAXC);
		int sy = rnd.next(-MAXC, MAXC);
		vector<pair<pii, int>> points;
		points.push_back({{sx, sy}, 1});
		for (int i = 1; i < 1000; ++i) {
			int x = rnd.next(-MAXC, MAXC);
			int y = rnd.next(-MAXC, MAXC);
			points.push_back({{x, y}, rnd.next(1, MAXT)});
		}
		shuffle(points.begin(), points.end());
		cout << sx << " " << sy << " " << sx << " " << sy << "\n";
		cout << szof(points) << "\n";
		for (auto p : points) {
			cout << p.ff.ff << " " << p.ff.ss << " " << p.ss << "\n";
		}
	}

	return 0;
}