#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;

void write_test(vector<int> test) 
{
    cout << test.size() << endl;
    for (int i = 0; i < int(test.size() - 1); i++)
        cout << test[i] << ' ';
    cout << test.back() << endl;
}

void gen(int n, int maxx)
{
    vector<int> test(n);
    map<int, int> used;
    for (int i = 0; i < n; i++)
    {
        test[i] = rnd.next(1, maxx);
        while (used[test[i]])
            test[i] = (test[i] % maxx) + 1;
        used[test[i]] = 1;
    }
    sort(test.rbegin(), test.rend());
    write_test(test);    
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    if (argc > 2)
        if (atoi(argv[2]) == 1)
            n = rnd.next(n/2, n);
    int maxx = int(1e9); 
    if (argc > 3)
        maxx = atoi(argv[3]);
    
    gen(n, maxx);
    return 0;
}