/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<int> mas[(int)3e5 + 10];
vector<pair<int, int> > arr, ans;
int h[(int)3e5 + 10];
 
void dfs(int v)
{
	for (int u: mas[v])
	{
		dfs(u);
		h[v] += h[u];
	}
} 

void solve() {
	int n, k;
	cin >> n >> k;
	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;
		x--;
		mas[x].push_back(i);	
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); mask++)
	{
		int cnt = 0;
		int cur = 0;
		for (int i = 0; i < n; i++)
		{
			if (mask & (1 << i))
				h[i] = 1;
			else
				h[i] = 0;
			cnt += h[i];
		}
		if (cnt > k)
			continue;
		dfs(0);
		for (int i = 0; i < n; i++)
			cur += (h[i] > 0);
		ans = max(ans, cur);
	}
	cout << ans << endl;
}
 
 
int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}