/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<int> mas[(int)3e5 + 10];
vector<pair<int, int> > arr;
vector<int> lists;
int h[(int)3e5 + 10], pw[4010], last[2010];
pair<int, int> mn[4010][13];
 
void dfs(int v)
{
	if (mas[v].size() == 0)
		lists.push_back(v);
	arr.push_back({h[v], v});
	for (int u: mas[v])
	{
		h[u] = h[v] + 1;
		dfs(u);
		arr.push_back({h[v], v});
	}
} 

int lca(int a, int b)
{
	int fi = min(last[a], last[b]);
	int se = max(last[a], last[b]);
	se++;
	int x = pw[se - fi];
	return min(mn[fi][x], mn[se - (1 << x)][x]).second;
}

void solve() {
	int n, k;
	cin >> n >> k;
	for (int i = 1; i < n; i++)
	{
		int x;
		cin >> x;
		x--;
		mas[x].push_back(i);	
	}
	h[0] = 0;
	dfs(0);
	if (sz(lists) <= k)
	{
		cout << n << endl;
		return;
	}
	vector<vector<int> > dp(sz(lists), vector<int>(k + 1, -INF));
	int m = sz(arr);
	pw[1] = 0;
	for (int i = 2; i <= m; i++)
		pw[i] = pw[i / 2] + 1;
	for (int i = 0; i < m; i++)
	{
		mn[i][0] = arr[i];
		last[arr[i].second] = i;
	}
	for (int j = 0; j < 12; j++)
		for (int i = 0; i + (1 << (j + 1)) <= m; i++)
			mn[i][j + 1] = min(mn[i][j], mn[i + (1 << j)][j]);
	int ans = 0;
	for (int i = 0; i < sz(lists); i++)
	{
		dp[i][1] = h[lists[i]];
		ans = max(ans, dp[i][1]);
	}
	for (int i = 1; i < sz(lists); i++)
	{
		for (int j = 0; j < i; j++)
		{
			int q = lca(lists[j], lists[i]);
			for (int w = 1; w < k; w++)
			{
				dp[i][w + 1] = max(dp[i][w + 1], dp[j][w] + h[lists[i]] - h[q]);
				ans = max(ans, dp[i][w + 1]);
			}
		}
	}
	cout << ans + 1 << endl;
}
 
 
int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}