#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>



using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n, k;
  cin >> n >> k;
  vector <int> p(n);
  vector <int> dep(n);
  for (int i = 1; i < n; i++) {
    cin >> p[i];
    p[i]--;
    dep[i] = dep[p[i]] + 1;
  }
  vector <int> ord;
  for (int i = 0; i < n; i++) {
    ord.push_back(i);
  }
  sort(ord.begin(), ord.end(), [&] (int u, int v) {
    return dep[u] > dep[v];
  });
  vector <bool> vis(n);
  vector <int> ans;
  for (int v : ord) {
    int len = 0;
    while (!vis[v]) {
      vis[v] = true;
      len++;
      v = p[v];
    }
    ans.push_back(len);
  }
  sort(ans.rbegin(), ans.rend());
  int tot = 0;
  for (int i = 0; i < k; i++) tot += ans[i];
  cout << tot << endl;
}
