// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXC = 1000, MAXT = 1000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int y0 = atoi(argv[2]);
	int r = atoi(argv[3]);

	auto gen_x = [&]() {
		return rnd.next(-MAXC, MAXC);
	};

	auto gen_y = [&]() {
		if (y0) {
			return 0;
		}
		return rnd.next(-MAXC, MAXC);
	};

	int xs = gen_x();
	int ys = gen_y();
	int xt = gen_x();
	int yt = gen_y();

	cout << xs << " " << ys << " " << xt << " " << yt << "\n";

	cout << n << "\n";

	for (int i = 0; i < n; ++i) {
		int x, y;
		while (true) {
			x = gen_x();
			y = gen_y();

			if ((x - xs) * (x - xs) + (y - ys) * (y - ys) >= r * r && (x - xt) * (x - xt) + (y - yt) * (y - yt) >= r * r) {
				break;
			}
		}
		int t = rnd.next(1, MAXT);
		cout << x << " " << y << " " << t << "\n";
	}

	return 0;
}